/*
 * Copyright 2016, Fabrice DESCLAUX <serpilliere@droids-corp.org>
 * Copyright 2016, Olivier MATZ <zer0@droids-corp.org>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef UCG_REENT_INTR_H_
#define UCG_REENT_INTR_H_

/* XXX doc */
void ucg_reent_intr(uint32_t *context, void *fct);
//void ucg_reent_intr(uint32_t *context);

/*
.align 4
.long my_var
*/
#define UCG_REENT_INTR(f)				\
	__asm__ volatile (                              \
		"SUB    SP, SP, 0x38     \n"		\
		"STR    LR, [SP]         \n"		\
		"ADD    R0, SP, 0x10     \n"		\
		"LDR    R1, =" #f "      \n"		\
		"BL     ucg_reent_intr   \n"		\
		"POP    {LR}             \n"		\
		"ADD    SP, SP, 0xC      \n"		\
		"BX     LR               \n"		\
		:					\
		:                                       \
		: /* No clobbers */                     \
	)

#define old_UCG_REENT_INTR(f)				\
	__asm__ volatile (                              \
		"SUB    SP, SP, 0x38     \n"		\
		"STR    LR, [SP]         \n"		\
		"ADD    R0, SP, 0x10     \n"		\
		"MOV    R1, %[value]     \n"		\
		"BL     ucg_reent_intr   \n"		\
		"POP    {LR}             \n"		\
		"ADD    SP, SP, 0xC      \n"		\
		"BX     LR               \n"		\
		:					\
		: [value]"r"   ((uint32_t)f)		\
		: /* No clobbers */                     \
	)

#define XXX_UCG_REENT_INTR(f)				\
	__asm__ volatile (                              \
		"SUB    SP, SP, 0x38     \n"		\
		"STR    LR, [SP]         \n"		\
		"ADD    R0, SP, 0x10     \n"		\
		"BL     ucg_reent_intr   \n"		\
		"POP    {LR}             \n"		\
		"ADD    SP, SP, 0xC      \n"		\
		"BX     LR               \n"		\
	)

#endif
